VG_BGA_Hopper = {};
VG_BGA_Hopper.moddir = g_currentModDirectory;
VG_BGA_Hopper.modName = g_currentModName;
if VG_BGA_Hopper.moddir:sub(-1) ~= '/' then
	VG_BGA_Hopper.moddir = VG_BGA_Hopper.moddir .. '/';
end;


function VG_BGA_Hopper:updateTick(dt)
  if self.bunkerFillLevel > 0 then
    if self.tipTriggers[1] ~= nil and 
       not self.tipTriggers[1].priceDropDisabled[FillUtil.FILLTYPE_SILAGE] then
      self.tipTriggers[1].priceDropTimer = TipTrigger.PRICE_DROP_DELAY;
    end;
  end;
end;
--[[
function VG_BGA_Hopper:updateTick(dt)
    if self.isServer then
        self.bunkerUseTime = self.bunkerUseTime + dt;
        --if self.bunkerUseTime > 1000 then

            if self.bunkerFillLevel > 0 then
                local oldFillLevel = self.bunkerFillLevel;
                local bunkerUseSpeed = self.bunkerUseSpeed*g_currentMission.missionInfo.timeScale*0.001;
                self:setFillLevel(self.bunkerFillLevel - self.bunkerUseTime * bunkerUseSpeed);
                local delta = oldFillLevel-self.bunkerFillLevel;
                if delta > 0 and self.digestateSiloTrigger ~= nil then
                    self.digestateSiloTrigger:setFillLevel(self.digestateSiloTrigger.fillLevel + delta*self.fillDeltaToManureDeltaScale);
                end;
                if delta > 0 and self.tipTriggers[1] ~= nil then
                  self.tipTriggers[1]:sellFillType(delta, FillUtil.FILLTYPE_SILAGE)
                end
            end;

            if self.liquidManureFillLevel > 0 then
                local oldFillLevel = self.liquidManureFillLevel;
                local bunkerUseSpeed = self.bunkerUseSpeed*g_currentMission.missionInfo.timeScale*0.0005;
                self:setFillLevel(self.liquidManureFillLevel - self.bunkerUseTime * bunkerUseSpeed, FillUtil.FILLTYPE_LIQUIDMANURE);
                local delta = oldFillLevel-self.liquidManureFillLevel;
                if delta > 0 and self.digestateSiloTrigger ~= nil then
                    self.digestateSiloTrigger:setFillLevel(self.digestateSiloTrigger.fillLevel + delta*self.liquidManureToDigestateScale);
                end;
            end

            self.bunkerUseTime = 0;
        --end;

        if self.bunkerFillLevel ~= self.sentBunkerFillLevel or self.liquidManureFillLevel ~= self.sentLiquidManureFillLevel then
            self:raiseDirtyFlags(self.bgaDirtyFlag);
            self.sentBunkerFillLevel = self.bunkerFillLevel;
            self.sentLiquidManureFillLevel = self.liquidManureFillLevel;
        end;
    end;
end;
]]

function VG_BGA_Hopper:setFillLevel(fillLevel, fillType, fillable, trigger)
    if fillType == FillUtil.FILLTYPE_LIQUIDMANURE then
        local oldLiquidManureFillLevel = self.liquidManureFillLevel;
        self.liquidManureFillLevel = Utils.clamp(fillLevel, 0, self.liquidManureCapacity);

        local delta = self.liquidManureFillLevel-oldLiquidManureFillLevel
        if delta > 0 and trigger ~= nil then
            trigger:sellFillType(delta, FillUtil.FILLTYPE_LIQUIDMANURE)
        end
    else
        local oldBunkerFillLevel = self.bunkerFillLevel;
        self.bunkerFillLevel = Utils.clamp(fillLevel, 0, self.bunkerCapacity);

        if self.bunkerFillLevel > oldBunkerFillLevel then
            self.bunkerPlaneAlpha = math.min(1, self.bunkerFillLevel / self.bunkerCapacity);
        end;
        self:updateDisplayNumbers(self.bunkerFillLevel);
        --[[
        local delta = self.bunkerFillLevel-oldBunkerFillLevel
        if delta > 0 and trigger ~= nil then
            trigger:sellFillType(delta, fillType)
        end
        ]]
    end
end;

function VG_BGA_Hopper:loadMap()
Bga.updateTick = Utils.prependedFunction(Bga.updateTick, VG_BGA_Hopper.updateTick);
--self.orig_updateTick = Bga.updateTick;
--self.orig_setFillLevel = Bga.setFillLevel;

--Bga.updateTick = VG_BGA_Hopper.updateTick;
--Bga.setFillLevel = VG_BGA_Hopper.setFillLevel;
end;

function VG_BGA_Hopper:deleteMap()
--Bga.updateTick = self.orig_updateTick;
--Bga.setFillLevel = self.orig_setFillLevel;
end;

function VG_BGA_Hopper:draw()
end;
function VG_BGA_Hopper:mouseEvent()
end;
function VG_BGA_Hopper:keyEvent()
end;
function VG_BGA_Hopper:update()
end;

addModEventListener(VG_BGA_Hopper);